import javax.swing.*;
import org.omg.CORBA.ORB;
import org.omg.CORBA.Policy;
import org.omg.PortableServer.POA;
import org.omg.PortableServer.IdAssignmentPolicyValue;
import org.omg.PortableServer.IdUniquenessPolicyValue;
import org.omg.PortableServer.ImplicitActivationPolicyValue;
import org.omg.PortableServer.LifespanPolicyValue;
import org.omg.PortableServer.RequestProcessingPolicyValue;
import org.omg.PortableServer.ServantRetentionPolicyValue;
import org.omg.PortableServer.ThreadPolicyValue;

import java.util.Properties;
import java.io.FileReader;
import java.io.BufferedReader;
import java.util.Properties;

import futurechat.Session;
import futurechat.ChatServer;
import futurechat.ChatClient;
import futurechat.Identity;
import java.awt.event.MouseEvent;
import java.awt.event.MouseMotionAdapter;
import java.awt.event.ComponentAdapter;
import java.awt.event.ComponentEvent;

/*
 * ChatClentGUI.java
 *
 * Created on February 25, 2003, 1:11 PM
 */

/**
 *
 * @author  Administrator
 */
public class ChatClentGUI extends javax.swing.JFrame {
    Session session = null;
    ChatServer server = null;
    
    public JTextArea getMessageWidget() {
        return this.messageWidget;
    }
    
    public void setSession(Session session) {
        this.session = session;
    }
    public void setServer(ChatServer server) {
        this.server=server;
    }
    /** Creates new form ChatClentGUI */
    public ChatClentGUI() {
        initComponents();
    }
    
    /** This method is called from within the constructor to
     * initialize the form.
     * WARNING: Do NOT modify this code. The content of this method is
     * always regenerated by the Form Editor.
     */
    private void initComponents() {//GEN-BEGIN:initComponents
        java.awt.GridBagConstraints gridBagConstraints;

        jPanel1 = new javax.swing.JPanel();
        sendButton = new javax.swing.JButton();
        messageOutWidget = new javax.swing.JTextField();
        jSplitPane1 = new javax.swing.JSplitPane();
        jScrollPane2 = new javax.swing.JScrollPane();
        messageWidget = new javax.swing.JTextArea();
        jPanel2 = new javax.swing.JPanel();
        jScrollPane1 = new javax.swing.JScrollPane();
        clientListWidget = new javax.swing.JList();
        jButton1 = new javax.swing.JButton();

        getContentPane().setLayout(new java.awt.GridBagLayout());

        addWindowListener(new java.awt.event.WindowAdapter() {
            public void windowClosing(java.awt.event.WindowEvent evt) {
                exitForm(evt);
            }
        });

        jPanel1.setLayout(new java.awt.GridBagLayout());

        sendButton.setText("send");
        sendButton.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                sendButtonActionPerformed(evt);
            }
        });

        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 1;
        gridBagConstraints.gridy = 0;
        jPanel1.add(sendButton, gridBagConstraints);

        messageOutWidget.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                messageOutWidgetActionPerformed(evt);
            }
        });

        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 0;
        gridBagConstraints.gridy = 0;
        gridBagConstraints.fill = java.awt.GridBagConstraints.HORIZONTAL;
        gridBagConstraints.weightx = 1.0;
        jPanel1.add(messageOutWidget, gridBagConstraints);

        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 0;
        gridBagConstraints.gridy = 1;
        gridBagConstraints.fill = java.awt.GridBagConstraints.HORIZONTAL;
        gridBagConstraints.anchor = java.awt.GridBagConstraints.NORTH;
        getContentPane().add(jPanel1, gridBagConstraints);

        jSplitPane1.setDividerLocation(400);
        jScrollPane2.setMinimumSize(new java.awt.Dimension(200, 0));
        jScrollPane2.setPreferredSize(new java.awt.Dimension(250, 250));
        messageWidget.setFont(new java.awt.Font("Dialog", 1, 18));
        jScrollPane2.setViewportView(messageWidget);

        jSplitPane1.setLeftComponent(jScrollPane2);

        jPanel2.setLayout(new java.awt.BorderLayout());

        jPanel2.setMinimumSize(new java.awt.Dimension(0, 0));
        jPanel2.setPreferredSize(new java.awt.Dimension(30, 100));
        clientListWidget.setPreferredSize(new java.awt.Dimension(30, 0));
        jScrollPane1.setViewportView(clientListWidget);

        jPanel2.add(jScrollPane1, java.awt.BorderLayout.CENTER);

        jButton1.setText("Refresh");
        jButton1.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jButton1ActionPerformed(evt);
            }
        });

        jPanel2.add(jButton1, java.awt.BorderLayout.NORTH);

        jSplitPane1.setRightComponent(jPanel2);

        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.fill = java.awt.GridBagConstraints.BOTH;
        gridBagConstraints.weightx = 1.0;
        gridBagConstraints.weighty = 1.0;
        getContentPane().add(jSplitPane1, gridBagConstraints);

        pack();
    }//GEN-END:initComponents
    
    private void jButton1ActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jButton1ActionPerformed
        ChatClient[] clients = session.listChatClients();
        DefaultListModel model = new  DefaultListModel();
        
        if (clients != null) {
            for (int i = 0; i < clients.length; i++) {
                Identity identity = clients[i].getIdentity();
                model.addElement(new String("(" + identity.username + ") " + identity.firstname + " " + identity.lastname));
            }
        }
        
        this.clientListWidget.setModel(model);
        
    }//GEN-LAST:event_jButton1ActionPerformed
    
    private void messageOutWidgetActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_messageOutWidgetActionPerformed
        session.send(this.messageOutWidget.getText());
    }//GEN-LAST:event_messageOutWidgetActionPerformed
    
    private void sendButtonActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_sendButtonActionPerformed
        session.send(this.messageOutWidget.getText());
    }//GEN-LAST:event_sendButtonActionPerformed
    
    /** Exit the Application */
    private void exitForm(java.awt.event.WindowEvent evt) {//GEN-FIRST:event_exitForm
        this.session.disconnect();
        System.exit(0);
    }//GEN-LAST:event_exitForm
    
    /**
     * @param args the command line arguments
     */
    public static void main(String[] args) {
        ChatClentGUI gui = new ChatClentGUI();
        
        
        String firstname = "Rob";
        String lastname = "Ratcliff";
        String username = "rrr6399";
        short age = 40;
        
        if (args.length == 4) {
            firstname = args[0];
            lastname = args[1];
            username = args[2];
            age = Short.parseShort(args[3]);
        }
        
        try {
            
            Properties props = System.getProperties();
            props.put("org.omg.CORBA.ORBInitialPort","1050");
            props.put("org.omg.CORBA.ORBInitialHost","futurelap");
            final ORB orb = ORB.init(args,props);
            
            String[] services = orb.list_initial_services();
            for (int i = 0; i < services.length; i++) {
                System.out.println(services[i]);
            }
            
            //final ORB orb = ORB.init(args, null);
            
            POA poa = (POA)orb.resolve_initial_references("RootPOA");
            Policy[] policies;
            policies = new Policy[] {};
            POA myPOA = poa.create_POA("MyPOA", poa.the_POAManager(), policies);
            
            futurechat.ChatClientImpl myServant = new futurechat.ChatClientImpl(firstname,lastname,username,age);
            byte[] myServantID1 = myPOA.activate_object(myServant);
            
            poa.the_POAManager().activate();
            
            new Thread(new Runnable() {
                public void run() {
                    try {
                        orb.run();
                    } catch (Exception ex) {
                        ex.printStackTrace();
                    }
                }
            }).start();
            
            FileReader file = new java.io.FileReader("C:\\ChatServer.ior");
            BufferedReader input = new java.io.BufferedReader(file);
            String ior = input.readLine();
            input.close();
            
            org.omg.CORBA.Object obj = orb.string_to_object(ior);
            if (obj == null) throw new RuntimeException();
            System.out.println(" naming object = " + obj);
            futurechat.ChatServer srv = futurechat.ChatServerHelper.narrow(obj);
            
            org.omg.CORBA.Object objn = orb.string_to_object("corbaname:iiop:1.2@futurelap:1050#ChatServer");
            System.out.println(" naming object = " + objn);
            
            if (srv == null) throw new RuntimeException();
            Session mySession = srv.register(myServant._this());
            long i0 = System.currentTimeMillis();
            for (int i = 0; i < 100; i++ ) {
                mySession.send("Hi for the " + i + " time!");
            }
            long i1 = System.currentTimeMillis();
            System.out.println("dt to send = " + (i1-i0)/100.0d + " ms");
            gui.setServer(srv);
            gui.setSession(mySession);
            myServant.setMessageWidget(gui.getMessageWidget());
            gui.setTitle("CORBA FutureChat: " + firstname + " " + lastname );
            gui.setSize(400,300);
            gui.show();
            //session.disconnect();
            //srv.shutdown();
            //System.exit(0);
            
        } catch (Exception ex) {
            ex.printStackTrace();
        }
    }

	public void jSplitPane1MouseDragged(MouseEvent e) {
        System.out.println("event = " + e);
    }

	public void jSplitPane1ComponentHidden(ComponentEvent e) { }
    
    // Variables declaration - do not modify//GEN-BEGIN:variables
    private javax.swing.JButton sendButton;
    private javax.swing.JScrollPane jScrollPane1;
    private javax.swing.JList clientListWidget;
    private javax.swing.JButton jButton1;
    private javax.swing.JSplitPane jSplitPane1;
    private javax.swing.JPanel jPanel2;
    private javax.swing.JScrollPane jScrollPane2;
    private javax.swing.JTextField messageOutWidget;
    private javax.swing.JPanel jPanel1;
    private javax.swing.JTextArea messageWidget;
    // End of variables declaration//GEN-END:variables
    
}
