import org.omg.CORBA.ORB;
import org.omg.CORBA.Policy;
import org.omg.PortableServer.POA;
import org.omg.PortableServer.IdAssignmentPolicyValue;
import org.omg.PortableServer.IdUniquenessPolicyValue;
import org.omg.PortableServer.ImplicitActivationPolicyValue;
import org.omg.PortableServer.LifespanPolicyValue;
import org.omg.PortableServer.RequestProcessingPolicyValue;
import org.omg.PortableServer.ServantRetentionPolicyValue;
import org.omg.PortableServer.ThreadPolicyValue;

import java.util.Properties;
import java.io.FileReader;
import java.io.BufferedReader;

import futurechat.Session;

public class ChatServerCallBackClient implements Runnable {
    
    private ORB orb;
    
    public void init(ORB _orb) {
        orb = _orb;
    }

    public void run() {
        try {
            orb.run();
        } catch (Exception ex) {
            ex.printStackTrace();
        }
    }

    public static void main(String args[]) {
        
        try {
            
            ORB orb = ORB.init(args, null);         
            POA poa = (POA)orb.resolve_initial_references("RootPOA");
            Policy[] policies;
            policies = new Policy[] {};
            POA myPOA = poa.create_POA("MyPOA", poa.the_POAManager(), policies);

            futurechat.ChatClientImpl myServant = new futurechat.ChatClientImpl("Rob", "Ratcliff", "rrr6399", (short)40);
            byte[] myServantID1 = myPOA.activate_object(myServant);

            poa.the_POAManager().activate();

            ChatServerCallBackClient handler = new ChatServerCallBackClient();
            handler.init(orb);
            new Thread(handler).start();
 
            FileReader file = new java.io.FileReader("C:\\ChatServer.ior");
            BufferedReader input = new java.io.BufferedReader(file);
            String ior = input.readLine();
            input.close();
            
            org.omg.CORBA.Object obj = orb.string_to_object(ior);
            if (obj == null) throw new RuntimeException();
            
            futurechat.ChatServer srv = futurechat.ChatServerHelper.narrow(obj);
 
            if (srv == null) throw new RuntimeException();
            Session session = srv.register(myServant._this());
            
            for (int i = 0; i < 10; i++ ) {
                Thread.sleep(1000);
                session.send("Hi for the " + i + " time!");
            }
            session.disconnect();
            srv.shutdown();
            System.exit(0);

        } catch (Exception ex) {
            ex.printStackTrace();
        }
    }
}


