import org.omg.CORBA.ORB;
import org.omg.CORBA.Policy;
import org.omg.PortableServer.POA;
import org.omg.PortableServer.IdAssignmentPolicyValue;
import org.omg.PortableServer.IdUniquenessPolicyValue;
import org.omg.PortableServer.ImplicitActivationPolicyValue;
import org.omg.PortableServer.LifespanPolicyValue;
import org.omg.PortableServer.RequestProcessingPolicyValue;
import org.omg.PortableServer.ServantRetentionPolicyValue;
import org.omg.PortableServer.ThreadPolicyValue;

import org.omg.CosNaming.NameComponent;
import org.omg.CosNaming.NamingContext;
import org.omg.CosNaming.NamingContextExt;
import org.omg.CosNaming.NamingContextExtHelper;

import java.util.Properties;
import java.io.PrintWriter;
import java.io.FileWriter;
import java.util.Properties;

public class ChatServerServer {
    
    public ChatServerServer() {
    }
    
    public static void main(String args[]) {
        
        try {
            
            Properties props = System.getProperties();
            props.put("org.omg.CORBA.ORBInitialPort","1050");
            props.put("org.omg.CORBA.ORBInitialHost","futurelap");
            ORB orb = ORB.init(args,props);

            
            String[] services = orb.list_initial_services();
            for (int i = 0; i < services.length; i++) {
                System.out.println(services[i]);
            }
	  
            POA poa = (POA)orb.resolve_initial_references("RootPOA");
            
            Policy[] policies;  
            policies = new Policy[] {
                poa.create_id_assignment_policy(IdAssignmentPolicyValue.USER_ID),
                poa.create_lifespan_policy(LifespanPolicyValue.TRANSIENT),
                poa.create_implicit_activation_policy(ImplicitActivationPolicyValue.NO_IMPLICIT_ACTIVATION)
            };
            
            POA myPOA = poa.create_POA("ChatServerPOA", poa.the_POAManager(), policies);
            
            futurechat.ChatServerImpl myServant = new futurechat.ChatServerImpl(orb,myPOA);
            myPOA.activate_object_with_id("MyServant".getBytes(), myServant);
            
            // IOR will be written to file
            String ior = orb.object_to_string(myPOA.servant_to_reference(myServant));
            FileWriter file = new java.io.FileWriter("C:\\ChatServer.ior");
            PrintWriter pfile = new java.io.PrintWriter(file);
            pfile.println(ior);
            pfile.flush();
            pfile.close();
	    
	    //org.omg.CORBA.Object obj = 
	    //orb.string_to_object("corbaloc:iiop:futurelap:9001/NameService");          
            org.omg.CORBA.Object obj = orb.resolve_initial_references("NameService");
	    if (obj != null ) {
                NamingContext rootContext = NamingContextExtHelper.narrow(obj);
                NameComponent[] nc = { new NameComponent("ChatServer","") };
                rootContext.rebind(nc,myPOA.servant_to_reference(myServant));
            }
            
            poa.the_POAManager().activate();
            
            orb.run();
        } catch (Exception ex) {
            ex.printStackTrace();
        }
    }
}
