package futurechat;
import java.util.*;
import org.omg.CORBA.ORB;
import org.omg.PortableServer.POA;

public class ChatServerImpl extends futurechat.ChatServerPOA {
    private ORB orb;
    private POA poa;
    private Hashtable clientList = new Hashtable();
    
    public ChatServerImpl(ORB orb, POA poa) {
	this._initialize_inheritance_tree();
	this.poa=poa;
	this.orb = orb;
    }
    
    public futurechat.Session register(ChatClient chatClient) {
	Identity identity = chatClient.getIdentity();
	this.clientList.put(identity.username,chatClient);
	System.out.println("registering " + identity.firstname + " " + identity.lastname);
	SessionImpl sessionImpl = new SessionImpl(this,chatClient);
	Session session = null;
	try {
	    this.poa.activate_object_with_id(identity.username.getBytes(), sessionImpl);
	    session = SessionHelper.narrow(poa.servant_to_reference(sessionImpl));
	} catch (Exception e) {
	    e.printStackTrace();
	}
	
    }
    
    public void shutdown() {
	System.out.println("shutting down");
	System.exit(0);
    }
    
    protected void sendAll(String message) {
	System.out.println("sending message to all clients");
	Enumeration enumeration = clientList.elements();
	while(enumeration.hasMoreElements()) {
	    ChatClient client = (ChatClient)enumeration.nextElement();
	    System.out.println("sending message " + message + " to " + client.getIdentity().username);
	    client.receive(message);
	}
    }
    
    protected ChatClient[] getChatClients() {
	Collection c = clientList.values();
	return (ChatClient[])c.toArray(new ChatClient[0]);
    }
    
    protected void unregister(String username) {
	try {
	    ChatClient client = (ChatClient)this.clientList.get(username);
	    System.out.println("deactivating " + username);
	    this.clientList.remove(username);
	    this.poa.deactivate_object(username.getBytes());
	} catch (Exception e) {
	    e.printStackTrace();
	}
	
    }
    
    public void _initialize_inheritance_tree() {
	// Do not edit! This is a method which is necessary for using delegation.
    }
    
    
}
